<template>
  <div class="p-6 space-y-2">
    <div
      v-if="paymentWithdrawalTextInfo?.Text?.length > 0"
      class="p-4 text-sm rounded bg-background5 --text4 font-normal mb-4 txt-info"
      v-html="paymentWithdrawalTextInfo?.Text"
    ></div>
    <h5
      v-if="
        cryptocurrencyRadios.radios && cryptocurrencyRadios.radios.length !== 0
      "
      class="--text4"
    >
      {{ $t("choose_your_cryptocurrency_network") }}
    </h5>
    <ui-radio-group
      v-model="selectCryptoCurrency"
      group-name="cryptocurrencyNetwork"
      class="grid grid-cols-3 gap-2"
      id="withdrawalCryptocurrencyNetwork"
    >
      <ui-radio-button
        v-for="cryptoNetwork in cryptocurrencyRadios.radios"
        :key="cryptoNetwork"
        :label="cryptoNetwork"
      >
        <ui-check-button :text="cryptoNetwork" variant="TEXT_ONLY" />
      </ui-radio-button>
    </ui-radio-group>
  </div>
  <div class="p-6">
    <el-form
      ref="ruleFormRef"
      :model="formData"
      status-icon
      :rules="getRule"
      label-width="210px"
      label-position="left"
      :validate-on-rule-change="false"
    >
      <el-form-item :label="$t('wallet_address')" prop="walletAddress">
        <el-input
          v-model="formData.walletAddress"
          id="withdrawalWalletAddress"
          oninput="this.value = this.value.replace(/[^a-zA-Z0-9]/g, '')"
        ></el-input>
      </el-form-item>
      <template v-if="isWithdrawalLimitEnabled">
        <el-form-item v-if="isAllowEligibleWithdrawal" :label="$t('eligible_withdrawal')">
          <div class="fc-primary font-bold">{{ eligibleWithdrawal }}</div>
        </el-form-item>
        <el-form-item prop="withdrawalLimit" :label="$t('remaining_rollover')">
          {{ remainingRollover }}
        </el-form-item>
      </template>
      <el-form-item :label="$t('amount')" prop="amount">
        <el-input
          v-model="formData.amount"
          @input="onInputValue($event, formData, 'amount')"
          :placeholder="amountPlaceholder"
          id="withdrawalAmount"
          @change="refreshTransactionFee"
        >
          <template v-if="checkedCurrency" #append>
            <span>000</span>
          </template>
        </el-input>
        <span
          v-if="checkedCurrency"
          class="order-1 mt-3 text-xs fc-hint font-normal"
          >{{
            $t(
              `withdrawal_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
            )
          }}</span
        >
      </el-form-item>
      <el-form-item>
        <div class="block">
          <div>
            {{ $t("transaction_fee") }} : {{ TransactionFee }} USDT
            <icons :is-refresh="true" @click="refreshTransactionFee" />
          </div>
        </div>
      </el-form-item>
      <el-form-item
        v-if="isPaymentPasswordEnable"
        :label="$t('payment_password')"
        prop="paymentPassword"
      >
        <el-input v-model="formData.paymentPassword" type="password" id="withdrawalPaymentPassword"></el-input>
      </el-form-item>
      <el-form-item>
        <div class="text-center">
          <el-button
            type="primary"
            round
            :disabled="isWithdrawProcessing"
            @click="submitWithdrawal(ruleFormRef)"
            >{{ $t("continue") }}
          </el-button>
        </div>
      </el-form-item>
    </el-form>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs } from "vue";
import { useCryptoCurrencyWithdrawal } from "@/composables/payment/withdrawal/useCryptoCurrencyWithdrawal";
import { usePaymentBankTransferWithdrawal } from "@/composables/payment/withdrawal/usePaymentBankTransferWithdrawal";
import { IGetPaymentGatewayBanksResponse } from "@/models/getPaymentGatewayBanksRespone";
import { ProfileDto } from "@/models/getProfileResponse";

export default defineComponent({
  props: {
    paymentBanks: {
      type: Object as PropType<IGetPaymentGatewayBanksResponse>,
      required: true,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
    isPaymentPasswordEnable: {
      type: Boolean,
      default: false,
    },
    isWithdrawalLimitEnabled: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const {
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled,
    } = toRefs(props);
    const {
      selectCryptoCurrency,
      withdrawalMin,
      withdrawalMax,
      cryptocurrencyRadios,
      refreshTransactionFee,
      TransactionFee,
      submitWithdrawal,
      getRule,
      formData,
      ruleFormRef,
      isWithdrawProcessing,
      checkedCurrency,
      amountPlaceholder,
      remainingRollover,
      eligibleWithdrawal,
    } = useCryptoCurrencyWithdrawal(
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled
    );
    const { getAssetImage, onInputValue, allowCompany, isAllowEligibleWithdrawal } = commonHelper;
    const {
      paymentWithdrawalTextInfo,
    } = usePaymentBankTransferWithdrawal(
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled
    );
    return {
      selectCryptoCurrency,
      withdrawalMin,
      withdrawalMax,
      cryptocurrencyRadios,
      refreshTransactionFee,
      TransactionFee,
      submitWithdrawal,
      getRule,
      formData,
      ruleFormRef,
      isWithdrawProcessing,
      checkedCurrency,
      amountPlaceholder,
      remainingRollover,
      eligibleWithdrawal,
      getAssetImage,
      paymentWithdrawalTextInfo,
      onInputValue,
      allowCompany,
      isAllowEligibleWithdrawal,
    };
  },
});
</script>
<style scoped lang="scss">
.txt-info {
  word-break: break-word;
}
</style>
